//
//  BUTimelineViewController.m
//  SingleViewDemo
//
//  Created by Niall Kavanagh on 2/26/13.
//  Copyright (c) 2013 Boston University. All rights reserved.
//

#import "BUTimelineViewController.h"

@interface BUTimelineViewController () {
    NSArray *tweets;
}

@end

@implementation BUTimelineViewController

- (void)viewDidLoad
{
    tweets = nil;
    
    [super viewDidLoad];
    
    [self loadTimeline];

    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{

    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [tweets count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"TweetCell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    NSDictionary *tweet = [tweets objectAtIndex:[indexPath row]];
    cell.textLabel.text = tweet[@"text"];
    
    
    return cell;
}

- (void)loadTimeline {
    NSURL *url = [NSURL URLWithString:@"https://api.twitter.com/1/statuses/user_timeline.json?include_entities=true&include_rts=true&screen_name=BU_Tweets"];
    
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue currentQueue]
                           completionHandler:
     ^(NSURLResponse *response, NSData *data, NSError *error) {
         if (error) {
             /* handle connection error */
         } else if (data) {
             /* parse data */
             NSError *parseError = nil;
             tweets = [NSJSONSerialization JSONObjectWithData:data options:0 error:&parseError];
             NSLog(@"Tweets: %@", tweets);
             if (parseError) {
                 /* handle parse error */
             } else if (tweets) {
                 /* ... */
                 
                 /* Update UI on main thread */
                 dispatch_async(dispatch_get_main_queue(), ^{
                     [self.tableView reloadData];
                 });
             }
         }
     }];
    

}

@end
